requests ipmi-tool to include lasted patch for supporting quanta server

Bug #1864612 reported by Zhanglei Mao
12
This bug affects 2 people
Affects Status Importance Assigned to Milestone
ipmitool (Ubuntu)
Fix Released
Low
Unassigned
Bionic
Triaged
Wishlist
Unassigned
Focal
Triaged
Wishlist
Unassigned
Groovy
Won't Fix
Wishlist
Unassigned
Hirsute
Fix Released
Wishlist
Unassigned
Impish
Fix Released
Low
Unassigned

Bug Description

[Impact]
Quanta server[1] is not supported by ipmitool, preventing IMPI events from being issued to this hardware.

1: https://www.quantatw.com/Quanta/english/product/qci_es.aspx

[Test Case]
On Quanta Server, you can use "ipmitool event 3" to send a simulation event for ECC error.
Using non patched ipmitool the DIMM location will not be decode.
And using the patches ipmitool (./src/ipmitool) will generate the DIMM location

------
[cchiang@pxe1 ipmitool]$ ipmitool -H 10.16.1.149 -U root sel elist
Password:
   1 | 05/26/2020 | 20:45:10 | Event Logging Disabled Event Log | Log area reset/cleared | Asserted
   2 | 05/26/2020 | 20:45:29 | Memory #0x53 | Correctable ECC | Asserted
[cchiang@pxe1 ipmitool]$ ./src/ipmitool -H 10.16.1.149 -U root sel elist
Password:
IANA PEN registry open failed: No such file or directory
   1 | 05/26/2020 | 04:45:10 PM EDT | Event Logging Disabled Event Log | Log area reset/cleared | Asserted
   2 | 05/26/2020 | 04:45:29 PM EDT | Memory #0x53 | Correctable ECC (CPU3_H7) | Asserted

[Original Report]
The existing ipmitool can't works for Quanta server as it didn't include latest patches, even in 20.04.

From Quanta feedback that pmitools in 20.04 can work for quanta server if apply this patch set:
https://github.com/ipmitool/ipmitool/commit/5c033c06abb45bc183f42cd758c61807ce953726.

Hopes to consideration this patch in 20.04 releasing.

Tags: patch

Related branches

CVE References

Revision history for this message
Bryce Harrington (bryce) wrote :

Confirmed this patch is in upstream master (landed Jul 2019), but was not included in the 1.8.18 release (which was in Jun 2019). (Upstream appears to release infrequently.)

I suspect the patch should apply cleanly to Ubuntu's ipmitools but I haven't attempted it. I am wondering if there are more patches needed than this one?

Changed in ipmitool (Ubuntu):
status: New → Triaged
importance: Undecided → Wishlist
Bryce Harrington (bryce)
tags: added: server-next
Revision history for this message
Bryce Harrington (bryce) wrote :

The server team discussed updating ipmitool at yesterday's team meeting. Tagging this as server-next and hoping one of the discussion participants will follow up.

tags: added: patch
Revision history for this message
Zhanglei Mao (zhanglei-mao) wrote :

Got feedback about what was fixed by the patch as below:

New IPMITOOL QCT support OEM DIMM description as below, so customer can know which CPU/DIMM/slot

Logged "Correctable ECC / SBE Warning Threshold (DIMM A0) - Asserted":

ipmitool -U admin -P admin -H 10.10.12.21 raw 0xa 0x44 0x0 0x0 0x2 0x0 0x0 0x00 0x0 0x1 0x0 0x4 0xc 0x87 0x6f 0xa0 0x00 0x00

Revision history for this message
Zhanglei Mao (zhanglei-mao) wrote :

It was also tested that freeipmi tools of ipmiconsole and ipmipower cmd works fine with Quanta server as it is standard for ipmi.

Revision history for this message
Chunyu Chiang (jiangjunyu) wrote :

The Ipmitool release 1.8.18 released on GitHub is the same package on the source forge. It just placed on the Github duplicated. Anyway for sure 1.8.18 formal release (released on 2016) did not include this fix.

So may we know the current status? Will Canonical backport the fix and put it into the trusted archive?

Revision history for this message
Bryce Harrington (bryce) wrote :

Yes, it is on the server team's list to look into, but I couldn't give an ETA right now.

The next step here would be to identify a set of steps to reproduce the problem synthetically. (This is required by the SRU acceptance process.) So for example, launch multipass, install xyz, set these parameters in these config files, run these commands, then look for thus-and-such output. If someone could help by preparing a 'paint-by-numbers' set of directions that would push the priority of this bug up. We already have a patch identified, we just need a way to prove it fixes the issue.

Revision history for this message
Chunyu Chiang (jiangjunyu) wrote :

Hello,

On Quanta Server, you can use "ipmitool event 3" to send a simulation event for ECC error.
Using non patched ipmitool the DIMM location will not be decode.
And using the patches ipmitool (./src/ipmitool) will generate the DIMM location

------
[cchiang@pxe1 ipmitool]$ ipmitool -H 10.16.1.149 -U root sel elist
Password:
   1 | 05/26/2020 | 20:45:10 | Event Logging Disabled Event Log | Log area reset/cleared | Asserted
   2 | 05/26/2020 | 20:45:29 | Memory #0x53 | Correctable ECC | Asserted
[cchiang@pxe1 ipmitool]$ ./src/ipmitool -H 10.16.1.149 -U root sel elist
Password:
IANA PEN registry open failed: No such file or directory
   1 | 05/26/2020 | 04:45:10 PM EDT | Event Logging Disabled Event Log | Log area reset/cleared | Asserted
   2 | 05/26/2020 | 04:45:29 PM EDT | Memory #0x53 | Correctable ECC (CPU3_H7) | Asserted

Paride Legovini (paride)
Changed in ipmitool (Ubuntu):
importance: Wishlist → Low
Revision history for this message
Christian Ehrhardt  (paelzer) wrote :

FYI - if one works on adding more recent patches to Ubuntus ipmitool, please consider adding the fix for [1] as well.

[1]: https://people.canonical.com/~ubuntu-security/cve/2020/CVE-2020-5208.html

Bryce Harrington (bryce)
description: updated
Changed in ipmitool (Ubuntu Bionic):
status: New → Triaged
Changed in ipmitool (Ubuntu Focal):
status: New → Triaged
Changed in ipmitool (Ubuntu Groovy):
status: New → Triaged
importance: Undecided → Wishlist
Changed in ipmitool (Ubuntu Focal):
importance: Undecided → Wishlist
Changed in ipmitool (Ubuntu Bionic):
importance: Undecided → Wishlist
Bryce Harrington (bryce)
Changed in ipmitool (Ubuntu Hirsute):
importance: Low → Wishlist
Revision history for this message
Bryce Harrington (bryce) wrote :

The CVE fixes mentioned by Christian are included in hirsute and impish's ipmitool:

ipmitool (1.8.18-10.1) unstable; urgency=high

  * Non-maintainer upload.
  * CVE-2020-5208: buffer overflows and potentially to remote code execution.
    Applied upstream patches:
    - CVE-2020-5208_1_Fix_buffer_overflow_vulnerabilities.patch
    - CVE-2020-5208_2-fru-Fix-buffer-overflow-in-ipmi_spd_print_fru.patch
    - CVE-2020-5208_3-session-Fix-buffer-overflow-in-ipmi_get_session_info.patch
    - CVE-2020-5208_4-channel-Fix-buffer-overflow.patch
    - CVE-2020-5208_5_lanp-Fix-buffer-overflows-in-get_lan_param_select.patch
    - CVE-2020-5208_6-fru-sdr-Fix-id_string-buffer-overflows.patch
    (Closes: #950761).

 -- Thomas Goirand <email address hidden> Fri, 19 Feb 2021 11:04:17 +0100

These aren't included in bionic or focal though, so may be worth investigation to include if we SRU this fix.

Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ipmitool - 1.8.18-10.1ubuntu1

---------------
ipmitool (1.8.18-10.1ubuntu1) impish; urgency=medium

  * d/p/add_basic_support_for_quanta.patch: Add basic support for Quanta
    - Enables support for IPMI events on Quanta Server hardware
      (LP: #1864612)

 -- Bryce Harrington <email address hidden> Wed, 30 Jun 2021 17:19:24 -0700

Changed in ipmitool (Ubuntu Impish):
status: Triaged → Fix Released
Revision history for this message
Christian Ehrhardt  (paelzer) wrote :

Hi,
While I think on the plus side this is
 + rather separate, somewhat low risk of regressing others
It also is
 - a new feature (people can somewhat be expected to upgrade for those)
 - the new feature it grants doesn't have a common ultra-important use case
 - Testability is restricted (as it is on quanta server only); we'd need a clear opt-in from people
   to be able and willing to test this on the right hardware
 - It was made available in newer releases (that was important)

For the reasons outlined above I'd drop server-next tag as the SRU of this does not seem "that important" IMHO.

Please speak up if
a) you think this is more important than how it appears (to me)
b) you have the required HW and are willing and able to test

tags: removed: server-next
Revision history for this message
Bryce Harrington (bryce) wrote :

[Groovy is no longer under active support.]

Changed in ipmitool (Ubuntu Hirsute):
status: Triaged → Fix Released
Changed in ipmitool (Ubuntu Groovy):
status: Triaged → Won't Fix
To post a comment you must log in.
This report contains Public information  
Everyone can see this information.

Other bug subscribers